//CIS 487
//2D Game
//Ben Catt
//Derek Petrtyl


// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream> // include important C/C++ stuff
#include <fstream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <vector>
#include <time.h>

#include <ddraw.h>     // directX includes
#include <dinput.h>
#include <dsound.h> // include dsound, dmusic
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include "T3DLIB1.H"
#include "T3DLIB3.H"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// default screen size
#define SCREEN_WIDTH    640  // size of screen
#define SCREEN_HEIGHT   480
#define SCREEN_BPP      8    // bits per pixel

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

// player directions
#define PLAYER_EAST         0
#define PLAYER_NEAST        1  
#define PLAYER_NORTH        2
#define PLAYER_NWEST        3
#define PLAYER_WEST         4
#define PLAYER_SWEST        5
#define PLAYER_SOUTH        6
#define PLAYER_SEAST        7
//zombie death
#define PLAYER_DEATH		8

#define WALL_ANIMATION_COLOR  29

// respawn constants
#define RESPAWN_TIME		5000
#define RESPAWN_DECREASE	5
//swing constant
#define SWING_TIME			1000
#define SWING_ANIM_TIME		150
//health decrease time
#define HEALTH_TIME			1500
//full minion spawn
#define MINION_TIME			40000
#define HEALTH_DECREASE		10000

// TYPES ///////////////////////////////////////////////////


// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);
void moveZombies();			//move all zombies
void moveHumans();			//move all humans
void moveMinions();			//move all minions
void spawnMinions();		//initally spawn the minions
int Zombie_Init(int spawnLoc);
int Human_Init(int spawnLoc);
void handleSpawns();		//reduce timers and spawn enemies
void zombieAttack(int z, int h);	//make zombie z attack human h, h = -1 means player
void player_dying();				//show player's character decay as he/she dies
void player_dying(int k);			//show zombies' decay
void minion_dying(int k);			//show minions' decay

// GLOBALS ////////////////////////////////////////////////

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

char buffer[80];                // used to print text

// directinput globals
LPDIRECTINPUT8        lpdi      = NULL;    // dinput object
LPDIRECTINPUTDEVICE8  lpdikey   = NULL;    // dinput keyboard
LPDIRECTINPUTDEVICE8  lpdimouse = NULL;    // dinput mouse
LPDIRECTINPUTDEVICE8  lpdijoy   = NULL;    // dinput joystick 
GUID                 joystickGUID;        // guid for main joystick
char                 joyname[80];         // name of joystick

// these contain the target records for all di input packets
UCHAR        keyboard_state[256]; // contains keyboard state table
DIMOUSESTATE mouse_state;         // contains state of mouse
DIJOYSTATE   joy_state;           // contains state of joystick

// game globals
std::vector<BOB>	zombies;	//zombies index 0 is player
std::vector<BOB>	humans;		//human enemies
std::vector<BOB>	lasers;		//laser sights for humans
std::vector<BOB>	minions;	//minion zombies that can be summoned
int spawnRates[8] = {RESPAWN_TIME,-1,-1,-1,-1,-1,-1,-1};	//spawn rates for each point, -1 means spawn point is "off"
int spawnTimers[8] = {0,RESPAWN_TIME,RESPAWN_TIME,RESPAWN_TIME,RESPAWN_TIME,RESPAWN_TIME,RESPAWN_TIME,RESPAWN_TIME};				//timer for each point
int dx,dy;             // general deltas used in collision detection
int score = 0;
int sound_ids[2]; // storage for 2 sound fx ids
int midi_ids[1]; // hold storage for 1 songs id
bool shiftPressed = 0;  //is whift currently pressed?
bool spacePressed = 0;
int gameState = 0; //0-main screen, 1-controls, 2-gameplay, 3-gameover
int endTimer = 0;
int healthTimer = 0;
int healthDec = 2;

// animation sequences for bob
int player_anims[9][4] = { {0,1,0,2},
                             {0+4,1+4,0+4,2+4},
                             {0+8,1+8,0+8,2+8},
                             {0+12,1+12,0+12,2+12},
                             {0+16,1+16,0+16,2+16},
                             {0+20,1+20,0+20,2+20},
                             {0+24,1+24,0+24,2+24},
                             {0+28,1+28,0+28,2+28},
							 {0+32,1+32,2+32,3+32} };

BITMAP_IMAGE background;      // the background
BITMAP_IMAGE title;				//title screen
BITMAP_IMAGE controls;			//controls screen
BITMAP_IMAGE gameover;			//gameover screen

PALETTEENTRY         game_palette[256]; // holds the main game palette
PALETTEENTRY		 menu_palette[256];


// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "OMG Zombies", // title
						    WS_POPUP | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
       Game_Main();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

// initialize directsound
DSound_Init();

// initialize directmusic
DMusic_Init();

// load in the digital sound
sound_ids[0] = DSound_Load_WAV("bat.WAV");
sound_ids[1] = DSound_Load_WAV("HWEAPON0.WAV");
DSound_Set_Volume(sound_ids[1],0);
// load midi file
midi_ids[0] = DMusic_Load_MIDI("MIDIFILE9.MID");

//seed rand
srand((unsigned)time(NULL));

//create sin and cos lookup tables
Build_Sin_Cos_Tables();

// initialize directdraw
DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);


#if 0 // directinput7 method

// first create the direct input object
if (DirectInputCreateEx(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput7, (void **)&lpdi,NULL)!=DI_OK)
   return(0);

// create a keyboard device  //////////////////////////////////
if (lpdi->CreateDeviceEx(GUID_SysKeyboard, IID_IDirectInputDevice7, (void **)&lpdikey, NULL)!=DI_OK)
   return(0);

#endif


// first create the direct input object
if (DirectInput8Create(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput8, (void **)&lpdi,NULL)!=DI_OK)
   return(0);

// create a keyboard device  //////////////////////////////////
if (lpdi->CreateDevice(GUID_SysKeyboard, &lpdikey, NULL)!=DI_OK)
   return(0);

// set cooperation level
if (lpdikey->SetCooperativeLevel(main_window_handle, 
                 DISCL_NONEXCLUSIVE | DISCL_BACKGROUND)!=DI_OK)
    return(0);

// set data format
if (lpdikey->SetDataFormat(&c_dfDIKeyboard)!=DI_OK)
   return(0);

// acquire the keyboard
if (lpdikey->Acquire()!=DI_OK)
   return(0);

///////////////////////////////////////////////////////////

// load the background
Load_Bitmap_File(&bitmap8bit, "GRASS.BMP");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);
Save_Palette(game_palette);

// create and load the background bitmap image
Create_Bitmap(&background, 0,0, 640, 480);
Load_Image_Bitmap(&background,&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

// load the background
Load_Bitmap_File(&bitmap8bit, "title.BMP");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);
Save_Palette(menu_palette);

// create and load the background bitmap image
Create_Bitmap(&title, 0,0, 640, 480);
Load_Image_Bitmap(&title,&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

// load the background
Load_Bitmap_File(&bitmap8bit, "controls.BMP");

// set the palette to background image palette
Set_Palette(menu_palette);

// create and load the background bitmap image
Create_Bitmap(&controls, 0,0, 640, 480);
Load_Image_Bitmap(&controls,&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

// load the background
Load_Bitmap_File(&bitmap8bit, "gameover.BMP");

// set the palette to background image palette
Set_Palette(menu_palette);

// create and load the background bitmap image
Create_Bitmap(&gameover, 0,0, 640, 480);
Load_Image_Bitmap(&gameover,&bitmap8bit,0,0,BITMAP_EXTRACT_MODE_ABS);
Unload_Bitmap_File(&bitmap8bit);

// now let's load in all the frames for the player!!!

zombies.push_back(BOB());	//create player bob

if (!Create_BOB(&zombies[0],0,0,56,72,36,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

// load the frames in 8 directions, 4 frames each
// each set of frames has a walk and a fire, frame sets
// are loaded in counter clockwise order looking down
// from a birds eys view or the x-z plane
	for (int direction = 0; direction < 8; direction++)
	{ 
		// build up file name
		sprintf(filename,"SKELSP%d.BMP",direction);

		// load in new bitmap file
		Load_Bitmap_File(&bitmap8bit,filename);

		Set_Palette(game_palette);

		//player animations
		Load_Frame_BOB(&zombies[0],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&zombies[0],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&zombies[0],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&zombies[0],&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL); 

		// unload the bitmap file
		Unload_Bitmap_File(&bitmap8bit);

		// set the animation sequences for player
		Load_Animation_BOB(&zombies[0],direction,4,player_anims[direction]);

    } // end for direction
	
    // load in new bitmap file
    Load_Bitmap_File(&bitmap8bit,"SKELSP8.BMP");

	Set_Palette(game_palette);

	//player animations
    Load_Frame_BOB(&zombies[0],&bitmap8bit,0+8*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&zombies[0],&bitmap8bit,1+8*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&zombies[0],&bitmap8bit,2+8*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&zombies[0],&bitmap8bit,3+8*4,4,0,BITMAP_EXTRACT_MODE_CELL); 
	// unload the bitmap file
    Unload_Bitmap_File(&bitmap8bit);

    // set the animation sequences for player
	Load_Animation_BOB(&zombies[0],8,4,player_anims[8]);

	// set up stating state of zombies
	Set_Animation_BOB(&zombies[0], 0);
	Set_Anim_Speed_BOB(&zombies[0], 4);
	Set_Vel_BOB(&zombies[0], 0,0);
	Set_Pos_BOB(&zombies[0], SCREEN_WIDTH/2-zombies[0].width/2, SCREEN_HEIGHT/2-zombies[0].height/2);

	zombies[0].health = 100;	
	zombies[0].minion_timer = 0;

	Human_Init(1);

// set clipping rectangle to screen extents so mouse cursor
// doens't mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height};
lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

// hide the mouse
ShowCursor(FALSE);

//play theme music
DMusic_Play(midi_ids[0]);

// return success
return(1);

} // end Game_Init


//initialize zombie stuff when they are spawned
int Zombie_Init(int spawnLoc)
{
	int dir;
	spawnLoc = rand()%8;
	char filename[80]; // used to build up files names

	zombies.push_back(BOB());

	int temp = zombies.size()-1;
	//change initial position based o spawn location
	if (!Create_BOB(&zombies[temp],0,0,56,72,36,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);
	
	for (int direction = 0; direction <= 8; direction++)
    { 
		// build up file name
		sprintf(filename,"SKELSP%d.BMP",direction);

		// load in new bitmap file
		Load_Bitmap_File(&bitmap8bit,filename);
		Load_Frame_BOB(&zombies[temp],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&zombies[temp],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&zombies[temp],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&zombies[temp],&bitmap8bit,3+direction*4,4,0,BITMAP_EXTRACT_MODE_CELL); 

		Load_Animation_BOB(&zombies[temp],direction,4,player_anims[direction]);
	}

	// set up stating state of zombies
	Set_Animation_BOB(&zombies[temp], 0);
	Set_Anim_Speed_BOB(&zombies[temp], 4);

	//right side middle
	if(spawnLoc == 0)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], SCREEN_WIDTH-zombies[temp].width, SCREEN_HEIGHT/2-zombies[temp].height/2);
		//give a random velocity vector
		dir = rand()%120 + 120;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//left side middle
	else if(spawnLoc == 1)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], 0, SCREEN_HEIGHT/2-zombies[temp].height/2);
		//give a random velocity vector
		dir = rand()%120 - 60;
		if(dir<0) dir+= 360;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//top middle
	else if(spawnLoc == 2)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], SCREEN_WIDTH/2-zombies[temp].width/2, 0);
		//give a random velocity vector
		dir = rand()%120 + 30;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//bottom middle
	else if(spawnLoc == 3)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], SCREEN_WIDTH/2-zombies[temp].width/2, SCREEN_HEIGHT-zombies[temp].height);
		//give a random velocity vector
		dir = rand()%120 + 210;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//top right
	else if(spawnLoc == 4)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], SCREEN_WIDTH-zombies[temp].width, 0);
		//give a random velocity vector
		dir = rand()%30 + 120;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//bottom left
	else if(spawnLoc == 5)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], 0, SCREEN_HEIGHT-zombies[0].height);
		//give a random velocity vector
		dir = rand()%30 + 300;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//top left
	else if(spawnLoc == 6)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], 0, 0);
		//give a random velocity vector
		dir = rand()%30;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//bottom right
	else if(spawnLoc == 7)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&zombies[temp], SCREEN_WIDTH-zombies[temp].width, SCREEN_HEIGHT-zombies[temp].height);
		//give a random velocity vector
		dir = rand()%30 + 210;
		Set_Vel_BOB(&zombies[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}

	//set animation based on which direction it started walking
	if(dir < 23 || dir > 337)
      Set_Animation_BOB(&zombies[temp],PLAYER_EAST);
	else if(dir > 22 && dir < 68)
		Set_Animation_BOB(&zombies[temp],PLAYER_SEAST);
	else if(dir > 67 && dir < 113)
		Set_Animation_BOB(&zombies[temp],PLAYER_SOUTH);
	else if(dir > 112 && dir < 158)
		Set_Animation_BOB(&zombies[temp],PLAYER_SWEST);
	else if(dir > 157 && dir < 203)
		Set_Animation_BOB(&zombies[temp],PLAYER_WEST);
	else if(dir > 202 && dir < 248)
		Set_Animation_BOB(&zombies[temp],PLAYER_NWEST);
	else if(dir > 247 && dir < 293)
		Set_Animation_BOB(&zombies[temp],PLAYER_NORTH);
	else if(dir > 292 && dir < 338)
		Set_Animation_BOB(&zombies[temp],PLAYER_NEAST);

	//set other attributes
	zombies[temp].dir = dir;			//set direction
	zombies[temp].move_timer = 1500;	//movement timer
	zombies[temp].health = 100;			//health
	zombies[temp].colliding = -2;		//not colliding with anything
	zombies[temp].swing_timer = SWING_TIME;	//timer for melee swings
	zombies[temp].swing_anim_timer = SWING_ANIM_TIME; //timer for melee anim
}

int Human_Init(int spawnLoc)
{
	int dir;
	spawnLoc = rand()%8;
	char filename[80]; // used to build up files names

	humans.push_back(BOB());
	lasers.push_back(BOB());

	int temp = humans.size()-1;

	if (!Create_BOB(&humans[temp],0,0,72,80,32,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
	return(0);

	if (!Create_BOB(&lasers[temp],0,0,150,150,2,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
	return(0);

	//load direction frames for laser

	// build up file name
	sprintf(filename,"laser.bmp");

	// load in new bitmap file
	Load_Bitmap_File(&bitmap8bit,filename);

	Load_Frame_BOB(&lasers[temp],&bitmap8bit,0,0,0,BITMAP_EXTRACT_MODE_CELL);
	Load_Frame_BOB(&lasers[temp],&bitmap8bit,1,1,0,BITMAP_EXTRACT_MODE_CELL);

	// unload the bitmap file
	Unload_Bitmap_File(&bitmap8bit);

	// set the animation for the laser
	Load_Animation_BOB(&lasers[temp],0,2,player_anims[temp]);
	lasers[temp].curr_animation = 0;
	
	//
	//Load frames for humans
	//
	for (int direction = 0; direction < 8; direction+=2)
	{ 
		// build up file name
		sprintf(filename,"DEDSP%d.BMP",direction);

		// load in new bitmap file
		Load_Bitmap_File(&bitmap8bit,filename);

		//player animations
		Load_Frame_BOB(&humans[temp],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&humans[temp],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&humans[temp],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&humans[temp],&bitmap8bit,3+direction*4,1,1,BITMAP_EXTRACT_MODE_CELL);

		// unload the bitmap file
		Unload_Bitmap_File(&bitmap8bit);

		// set the animation sequences for player
		Load_Animation_BOB(&humans[temp],direction,4,player_anims[direction]);

    } // end for direction


	//right side middle
	if(spawnLoc == 0)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], SCREEN_WIDTH-humans[temp].width, SCREEN_HEIGHT/2-humans[temp].height/2);
		//give a random velocity vector
		dir = rand()%120 + 120;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//left side middle
	else if(spawnLoc == 1)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], 0, SCREEN_HEIGHT/2-humans[temp].height/2);
		//give a random velocity vector
		dir = rand()%120 - 60;
		if(dir<0) dir+= 360;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//top middle
	else if(spawnLoc == 2)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], SCREEN_WIDTH/2-humans[temp].width/2, 0);
		//give a random velocity vector
		dir = rand()%120 + 30;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//bottom middle
	else if(spawnLoc == 3)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], SCREEN_WIDTH/2-humans[temp].width/2, SCREEN_HEIGHT-humans[temp].height);
		//give a random velocity vector
		dir = rand()%120 + 210;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//top right
	else if(spawnLoc == 4)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], SCREEN_WIDTH-humans[temp].width, 0);
		//give a random velocity vector
		dir = rand()%30 + 120;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//bottom left
	else if(spawnLoc == 5)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], 0, SCREEN_HEIGHT-humans[temp].height);
		//give a random velocity vector
		dir = rand()%30 + 300;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//top left
	else if(spawnLoc == 6)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], 0, 0);
		//give a random velocity vector
		dir = rand()%30;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//bottom right
	else if(spawnLoc == 7)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&humans[temp], SCREEN_WIDTH-humans[temp].width, SCREEN_HEIGHT-humans[temp].height);
		//give a random velocity vector
		dir = rand()%30 + 210;
		Set_Vel_BOB(&humans[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	
	Set_Animation_BOB(&humans[temp], 0);
	Set_Anim_Speed_BOB(&humans[temp], 8);

	//set animation based on which direction it started walking
	if(dir < 46 || dir > 314)
      Set_Animation_BOB(&humans[temp],PLAYER_EAST);
	else if(dir > 45 && dir < 136)
		Set_Animation_BOB(&humans[temp],PLAYER_SOUTH);
	else if(dir > 135 && dir < 226)
		Set_Animation_BOB(&humans[temp],PLAYER_WEST);
	else if(dir > 225 && dir < 315)
		Set_Animation_BOB(&humans[temp],PLAYER_NORTH);

	//set other attributes
	humans[temp].dir = dir;			//set direction
	humans[temp].move_timer = 1500;	//movement timer
	humans[temp].health = 100;			//health
	humans[temp].colliding = -2;		//not colliding with anything
	humans[temp].swing_timer = SWING_TIME;	//timer for melee swings
	humans[temp].swing_anim_timer = SWING_ANIM_TIME; //timer for melee anim
}


int Minion_Init(int spawnLoc)
{
	char filename[80]; // used to build up files names

	minions.push_back(BOB());

	int temp = minions.size()-1;
	//change initial position based o spawn location
	if (!Create_BOB(&minions[temp],0,0,56,72,36,
           BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);
	
	for (int direction = 0; direction <= 8; direction++)
    { 
		// build up file name
		sprintf(filename,"SKELSP%d.BMP",direction);

		// load in new bitmap file
		Load_Bitmap_File(&bitmap8bit,filename);
		Load_Frame_BOB(&minions[temp],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&minions[temp],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&minions[temp],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
		Load_Frame_BOB(&minions[temp],&bitmap8bit,3+direction*4,4,0,BITMAP_EXTRACT_MODE_CELL); 

		Load_Animation_BOB(&minions[temp],direction,4,player_anims[direction]);
	}

	// set up stating state of zombies
	Set_Animation_BOB(&minions[temp], 0);
	Set_Anim_Speed_BOB(&minions[temp], 4);

	//holds direction of initial velocity
	int dir;

	//east of player
	if(spawnLoc == 0)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&minions[temp], zombies[0].x+zombies[0].width, zombies[0].y);
		//give a random velocity vector
		dir = rand()%120 - 60;
		if(dir<0) dir+= 360;
		Set_Vel_BOB(&minions[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//west of player
	else if(spawnLoc == 1)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&minions[temp], zombies[0].x-zombies[0].width, zombies[0].y);
		//give a random velocity vector
		dir = rand()%120 + 120;
		Set_Vel_BOB(&minions[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//north of player
	else if(spawnLoc == 2)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&minions[temp], zombies[0].x, zombies[0].y-zombies[0].height);
		//give a random velocity vector
		dir = rand()%120 + 210;
		Set_Vel_BOB(&minions[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}
	//south of player
	else if(spawnLoc == 3)
	{
		//base their position off of their spawn point
		Set_Pos_BOB(&minions[temp], zombies[0].x, zombies[0].y+zombies[0].height);
		//give a random velocity vector
		dir = rand()%120 + 30;
		Set_Vel_BOB(&minions[temp],2.0*cos_look[dir],2.0*sin_look[dir]);
	}

	//set animation based on which direction it started walking
	if(dir < 23 || dir > 337)
      Set_Animation_BOB(&minions[temp],PLAYER_EAST);
	else if(dir > 22 && dir < 68)
		Set_Animation_BOB(&minions[temp],PLAYER_SEAST);
	else if(dir > 67 && dir < 113)
		Set_Animation_BOB(&minions[temp],PLAYER_SOUTH);
	else if(dir > 112 && dir < 158)
		Set_Animation_BOB(&minions[temp],PLAYER_SWEST);
	else if(dir > 157 && dir < 203)
		Set_Animation_BOB(&minions[temp],PLAYER_WEST);
	else if(dir > 202 && dir < 248)
		Set_Animation_BOB(&minions[temp],PLAYER_NWEST);
	else if(dir > 247 && dir < 293)
		Set_Animation_BOB(&minions[temp],PLAYER_NORTH);
	else if(dir > 292 && dir < 338)
		Set_Animation_BOB(&minions[temp],PLAYER_NEAST);

	//set other attributes
	minions[temp].dir = dir;			//set direction
	minions[temp].move_timer = 1500;	//movement timer
	minions[temp].health = 100;			//health
	minions[temp].colliding = -2;		//not colliding with anything
	minions[temp].swing_timer = SWING_TIME;	//timer for melee swings
	minions[temp].swing_anim_timer = SWING_ANIM_TIME; //timer for melee anim
}
///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// stop all sounds
DSound_Stop_All_Sounds();

// delete all sounds
DSound_Delete_All_Sounds();

// shutdown directsound
DSound_Shutdown();

// delete all the music
DMusic_Delete_All_MIDI();

// shutdown directmusic
DMusic_Shutdown();

// kill the background
Destroy_Bitmap(&background);

for(int k=0;k<zombies.size();k++)
{
	// kill zombies
	Destroy_BOB(&zombies[k]);
}

for(int k=0;k<humans.size();k++)
{
	//kill humans
	Destroy_BOB(&humans[k]);
	Destroy_BOB(&lasers[k]);
}

// release keyboard
lpdikey->Unacquire();
lpdikey->Release();
lpdi->Release();

// shutdonw directdraw
DDraw_Shutdown();

// return success
return(1);
} // end Game_Shutdown

///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!


int          index;             // looping var

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

// lock the back buffer
DDraw_Lock_Back_Surface();

if(gameState == 0)
{
	// draw the title screen
	Set_Palette(menu_palette);
	Draw_Bitmap(&title, back_buffer, back_lpitch, 0);
}

if(gameState == 1)
{
	// draw the controls screen
	Set_Palette(menu_palette);
	Draw_Bitmap(&controls, back_buffer, back_lpitch, 0);
}

if(gameState == 2)
{
	// draw the background image
	Set_Palette(game_palette);
	Draw_Bitmap(&background, back_buffer, back_lpitch, 0);
}

if(gameState == 3)
{
	// draw the background image
	Set_Palette(menu_palette);
	Draw_Bitmap(&gameover, back_buffer, back_lpitch, 0);
}

// unlock the back buffer
DDraw_Unlock_Back_Surface();

// get player input

// get the keyboard data
lpdikey->GetDeviceState(256, (LPVOID)keyboard_state);

if(gameState == 0)
{
	if(keyboard_state[DIK_SPACE])
	{
		if(!spacePressed)
			gameState = 1;
		spacePressed = true;
	}
	else spacePressed = false;

	if(DMusic_Status_MIDI(midi_ids[0]) == MIDI_STOPPED)
		DMusic_Play(midi_ids[0]);
}

if(gameState == 1)
{
	if(keyboard_state[DIK_SPACE])
	{
		if(!spacePressed)
			gameState = 2;
		spacePressed = true;
	}
	else spacePressed = false;

	if(DMusic_Status_MIDI(midi_ids[0]) == MIDI_STOPPED)
		DMusic_Play(midi_ids[0]);
}

if(gameState == 2)
{
	if(DMusic_Status_MIDI(midi_ids[0]) == MIDI_STOPPED)
		DMusic_Play(midi_ids[0]);

	// reset motion flag
	zombies[0].moving = 0;

	// test direction of motion, this is a good example of testing the keyboard
	// although the code could be optimized this is more educational

	if (keyboard_state[DIK_RIGHT] && keyboard_state[DIK_UP]) 
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].x+=2;
			zombies[0].y-=2;
			dx=2; dy=-2;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_NEAST)
			{
				Set_Animation_BOB(&zombies[0],PLAYER_NEAST);
			}
			player_dying();
		}	
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_LEFT] && keyboard_state[DIK_UP]) 
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].x-=2;
			zombies[0].y-=2;
			dx=-2; dy=-2;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_NWEST)
				Set_Animation_BOB(&zombies[0],PLAYER_NWEST);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_LEFT] && keyboard_state[DIK_DOWN]) 
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].x-=2;
			zombies[0].y+=2;
			dx=-2; dy=2;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_SWEST)
				Set_Animation_BOB(&zombies[0],PLAYER_SWEST);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_RIGHT] && keyboard_state[DIK_DOWN]) 
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].x+=2;
			zombies[0].y+=2;
			dx=2; dy=2;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_SEAST)
				Set_Animation_BOB(&zombies[0],PLAYER_SEAST);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_RIGHT]) 
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].x+=2;
			dx=2; dy=0;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_EAST)
				Set_Animation_BOB(&zombies[0],PLAYER_EAST);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_LEFT])  
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].x-=2;
			dx=-2; dy=0; 

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_WEST)
				Set_Animation_BOB(&zombies[0],PLAYER_WEST);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_UP])    
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].y-=2;
			dx=0; dy=-2;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_NORTH)
				Set_Animation_BOB(&zombies[0],PLAYER_NORTH);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	if (keyboard_state[DIK_DOWN])  
	{
		if(zombies[0].health > 0)
		{
			// move player
			zombies[0].y+=2;
			dx=0; dy=+2;

			// set motion flag
			zombies[0].moving = 1;

			// check animation needs to change
			if (zombies[0].curr_animation != PLAYER_SOUTH)
				Set_Animation_BOB(&zombies[0],PLAYER_SOUTH);
			player_dying();
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else
	{
		dx = 0;
		dy = 0;
	}

	//if moving animate it
	if (zombies[0].moving)
	{
		if(zombies[0].health > 0)
		{
			// animate player
			Animate_BOB(&zombies[0]);

			// check if player is off screen
			if (zombies[0].x < 0 || zombies[0].x > (screen_width - zombies[0].width))
				zombies[0].x-=dx;

			if (zombies[0].y < 0 || zombies[0].y > (screen_height - zombies[0].height))
				zombies[0].y-=dy;

			if(zombies[0].swing_anim_timer < SWING_ANIM_TIME && zombies[0].health <= 60)
			{
				if(zombies[0].dir < 23 || zombies[0].dir > 337)
				  Set_Animation_BOB(&zombies[0],PLAYER_EAST);
				else if(zombies[0].dir > 22 && zombies[0].dir < 68)
					Set_Animation_BOB(&zombies[0],PLAYER_SEAST);
				else if(zombies[0].dir > 67 && zombies[0].dir < 113)
					Set_Animation_BOB(&zombies[0],PLAYER_SOUTH);
				else if(zombies[0].dir > 112 && zombies[0].dir < 158)
					Set_Animation_BOB(&zombies[0],PLAYER_SWEST);
				else if(zombies[0].dir > 157 && zombies[0].dir < 203)
					Set_Animation_BOB(&zombies[0],PLAYER_WEST);
				else if(zombies[0].dir > 202 && zombies[0].dir < 248)
					Set_Animation_BOB(&zombies[0],PLAYER_NWEST);
				else if(zombies[0].dir > 247 && zombies[0].dir < 293)
					Set_Animation_BOB(&zombies[0],PLAYER_NORTH);
				else if(zombies[0].dir > 292 && zombies[0].dir < 338)
					Set_Animation_BOB(&zombies[0],PLAYER_NEAST);
					
				zombies[0].curr_frame = zombies[0].curr_frame - zombies[0].curr_frame%4 + 3;
			}
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	} // end if
	else //if not moving reset animation
	{
		if(zombies[0].health > 0)
		{		
			zombies[0].curr_frame = zombies[0].curr_frame - zombies[0].curr_frame%4;
		}
		else
		{
			zombies[0].moving = false;
			player_dying();
		}
	}

	if(keyboard_state[DIK_LSHIFT] && !shiftPressed)
	{
		spawnMinions();
		shiftPressed = 1;
	}
	else if(!keyboard_state[DIK_LSHIFT])	shiftPressed = 0;

	//update timers
	zombies[0].swing_timer += Get_Clock() - start_clock_count + 30;
	zombies[0].swing_anim_timer += Get_Clock() - start_clock_count + 30;
	zombies[0].health_timer += Get_Clock() - start_clock_count + 30;
	zombies[0].minion_timer += Get_Clock() - start_clock_count + 30;
	healthTimer += Get_Clock() - start_clock_count + 30;

	//handle timers
	if(zombies[0].swing_timer > SWING_TIME)
		zombies[0].swing_timer = SWING_TIME;

	if(zombies[0].swing_anim_timer > SWING_ANIM_TIME)
	zombies[0].swing_anim_timer = SWING_ANIM_TIME;

	if(zombies[0].swing_anim_timer < SWING_ANIM_TIME)
		zombies[0].curr_frame = zombies[0].curr_frame - zombies[0].curr_frame%4 + 3;

	if(zombies[0].health_timer > HEALTH_TIME)
		zombies[0].health_timer = HEALTH_TIME;

	if(zombies[0].minion_timer > MINION_TIME)
		zombies[0].minion_timer = MINION_TIME;

	if(healthTimer > HEALTH_DECREASE)
	{
		healthTimer = 0;
		if(healthDec < 11)
			healthDec++;
	}

	//animate zombies
	for(int k=1;k<zombies.size();k++)
	{
		// only animate if zombies is moving
		if (zombies[k].moving)
		{
		   // animate zombie
		   Animate_BOB(&zombies[k]);

		} // end if
		else
		{
			zombies[k].curr_frame = zombies[k].curr_frame - zombies[k].curr_frame%4;
		}


		if(zombies[k].swing_anim_timer < SWING_ANIM_TIME)
			zombies[k].curr_frame = zombies[k].curr_frame - zombies[k].curr_frame%4 + 3;
	}

	//animate minions
	for(int k=0;k<minions.size();k++)
	{
		Animate_BOB(&minions[k]);
		//// only animate if minions is moving
		//if (minions[k].moving)
		//{
		//   // animate zombie
		//   Animate_BOB(&minions[k]);

		//} // end if
		//else
		//{
		//	minions[k].curr_frame = minions[k].curr_frame - minions[k].curr_frame%4;
		//}

		if(minions[k].swing_anim_timer < SWING_ANIM_TIME)
			minions[k].curr_frame = minions[k].curr_frame - minions[k].curr_frame%4 + 3;
	}

	//animate humans
	for(int k=0;k<humans.size();k++)
	{
		// only animate if humans is moving
		//if (humans[k].moving)
		//{
		   // animate zombie
		   Animate_BOB(&humans[k]);

		//} // end if
		/*else
		{
			humans[k].curr_frame = humans[k].curr_frame - humans[k].curr_frame%4;
		}*/


		if(humans[k].swing_anim_timer < SWING_ANIM_TIME)
			humans[k].curr_frame = humans[k].curr_frame - humans[k].curr_frame%4 + 3;
	}

	if(KEY_DOWN(VK_SPACE))
	{
		if(zombies[0].swing_timer >= SWING_TIME && zombies[0].health > 0)
		{
			zombies[0].swing_timer = 0;
			zombies[0].swing_anim_timer = 0;
		}
	}
	else spacePressed = false;
	
	if(endTimer > 2000)
	{
		endTimer = 0;
		gameState = 3;
	}

	if(zombies[0].health <= 0)
		endTimer += Get_Clock() - start_clock_count + 30;

	//play melee sound
	if(zombies[0].swing_timer == 0)
		DSound_Play(sound_ids[0],0);

	//decrease health by about 10 a sec
	if(zombies[0].health_timer == HEALTH_TIME)
	{
		zombies[0].health -= healthDec;
		zombies[0].health_timer = 0;
	}

	//move the zombies
	moveZombies();

	//move the minions
	moveMinions();

	//move the humans
	moveHumans();

	//spawn anything that needs to be spawned
	handleSpawns();

	if(zombies[0].health < 0) zombies[0].health = 0; //keep health at 0

	// draw all the zombies
	for(int k = 1;k<zombies.size();k++)
		Draw_BOB(&zombies[k], lpddsback);

	//draw all the minions
	for(int k = 0;k<minions.size();k++)
		Draw_BOB(&minions[k], lpddsback);

	//draw all humans
	for(int k = 0;k<humans.size();k++)
	{
		if(humans[k].health > 0)
		{
			//switch to correct rotation of laser
			lasers[k].curr_frame = humans[k].curr_animation/2%2;
			if(humans[k].curr_animation == 0)
			{
				lasers[k].x = humans[k].x + humans[k].width;
				lasers[k].y = humans[k].y - 50;
			}
			else if(humans[k].curr_animation == 2)
			{
				lasers[k].x = humans[k].x - 39;
				lasers[k].y = humans[k].y - lasers[k].height;
			}
			else if(humans[k].curr_animation == 4)
			{
				lasers[k].x = humans[k].x - lasers[k].width;
				lasers[k].y = humans[k].y - 50;
			}
			else if(humans[k].curr_animation == 6)
			{
				lasers[k].x = humans[k].x - 39;
				lasers[k].y = humans[k].y + humans[k].height;
			}
			if(humans[k].swing_anim_timer >= SWING_ANIM_TIME)
				Draw_BOB(&lasers[k], lpddsback);
			Draw_BOB(&humans[k], lpddsback);
		}
	}

	//draw the player
	if(zombies[0].health > 0)
		Draw_BOB(&zombies[0], lpddsback);

	for(int k = 0;k < humans.size();k++)
	{
		if(humans[k].y > zombies[0].y)
			Draw_BOB(&humans[k], lpddsback);
	}

	for(int k = 0;k < zombies.size();k++)
	{
		if(zombies[k].y > zombies[0].y)
			Draw_BOB(&zombies[k], lpddsback);
	}

	// draw health and score
	sprintf(buffer,"Health: %d",zombies[0].health);
	Draw_Text_GDI(buffer,0,0,RGB(0,0,0),lpddsback);

	sprintf(buffer,"Score: %d",score);
	Draw_Text_GDI(buffer,100,0,RGB(0,0,0),lpddsback);

	sprintf(buffer,"Spawn CD: %d%%",zombies[0].minion_timer*100/MINION_TIME);
	Draw_Text_GDI(buffer,0,20,RGB(0,0,0),lpddsback);

	Draw_Text_GDI("YOU",zombies[0].x+12,zombies[0].y-15,RGB(255,0,0),lpddsback);
}

if(gameState == 3)
{	
	if(keyboard_state[DIK_SPACE])
	{
		if(!spacePressed && endTimer > 2000)
		{
			char filename[80]; // used to build up files names
			endTimer = 0;
			gameState = 2;

			//reset everything
			humans.clear();
			zombies.clear();
			minions.clear();

			zombies.push_back(BOB());	//create player bob

			if (!Create_BOB(&zombies[0],0,0,56,72,36,
					   BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
			   return(0);

			// load the frames in 8 directions, 4 frames each
			// each set of frames has a walk and a fire, frame sets
			// are loaded in counter clockwise order looking down
			// from a birds eys view or the x-z plane
				for (int direction = 0; direction < 8; direction++)
				{ 
					// build up file name
					sprintf(filename,"SKELSP%d.BMP",direction);

					// load in new bitmap file
					Load_Bitmap_File(&bitmap8bit,filename);

					//player animations
					Load_Frame_BOB(&zombies[0],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
					Load_Frame_BOB(&zombies[0],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
					Load_Frame_BOB(&zombies[0],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
					Load_Frame_BOB(&zombies[0],&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL); 

					// unload the bitmap file
					Unload_Bitmap_File(&bitmap8bit);

					// set the animation sequences for player
					Load_Animation_BOB(&zombies[0],direction,4,player_anims[direction]);

				} // end for direction
				
				// load in new bitmap file
				Load_Bitmap_File(&bitmap8bit,"SKELSP8.BMP");

				//player animations
				Load_Frame_BOB(&zombies[0],&bitmap8bit,0+8*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
				Load_Frame_BOB(&zombies[0],&bitmap8bit,1+8*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
				Load_Frame_BOB(&zombies[0],&bitmap8bit,2+8*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
				Load_Frame_BOB(&zombies[0],&bitmap8bit,3+8*4,4,0,BITMAP_EXTRACT_MODE_CELL); 
				// unload the bitmap file
				Unload_Bitmap_File(&bitmap8bit);

				// set the animation sequences for player
				Load_Animation_BOB(&zombies[0],8,4,player_anims[8]);

				// set up stating state of zombies
				Set_Animation_BOB(&zombies[0], 0);
				Set_Anim_Speed_BOB(&zombies[0], 4);
				Set_Vel_BOB(&zombies[0], 0,0);
				Set_Pos_BOB(&zombies[0], SCREEN_WIDTH/2-zombies[0].width/2, SCREEN_HEIGHT/2-zombies[0].height/2);

				zombies[0].health = 100;	
				zombies[0].minion_timer = 0;

				Human_Init(1);

			spawnRates[0] = RESPAWN_TIME;
			spawnTimers[0] = 0;
			for(int k = 1;k <= 8;k++)
			{
				spawnRates[k] = -1;
				spawnTimers[k] = RESPAWN_TIME;
			}
			score = 0;
		}
		spacePressed = true;
	}
	else spacePressed = false;

	if(DMusic_Status_MIDI(midi_ids[0]) == MIDI_STOPPED)
		DMusic_Play(midi_ids[0]);

	sprintf(buffer,"Final Score: %d",score);
	Draw_Text_GDI(buffer,240,435,RGB(32,32,32),lpddsback);

	endTimer += Get_Clock() - start_clock_count + 30;
	healthDec = 2;
}

// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////

void moveZombies()
{
	//move each of the zombies
	for(int k = 1;k<zombies.size();k++)
	{
		//update timers
		zombies[k].swing_timer += Get_Clock() - start_clock_count + 30;
		zombies[k].swing_anim_timer += Get_Clock() - start_clock_count + 30;
		zombies[k].move_timer -= Get_Clock() - start_clock_count + 30;		
		zombies[k].health_timer += Get_Clock() - start_clock_count + 30;
	
		//handle timers
		if(zombies[k].swing_timer > SWING_TIME)
			zombies[k].swing_timer = SWING_TIME;	

		if(zombies[k].swing_anim_timer > SWING_ANIM_TIME)
			zombies[k].swing_anim_timer = SWING_ANIM_TIME;

		if(zombies[k].health_timer > HEALTH_TIME)
		{
			zombies[k].health -= 10;
			zombies[k].health_timer = 0;
		}

		if(zombies[k].move_timer < 0)
		{
			//reset timer
			zombies[k].move_timer = 1500;
			//give a random velocity vector
			zombies[k].dir = rand()%180 + zombies[k].dir - 90;
			if(zombies[k].dir > 360) zombies[k].dir -= 360;
			else if(zombies[k].dir < 0) zombies[k].dir += 360;
			Set_Vel_BOB(&zombies[k],2.0*cos_look[zombies[k].dir],2.0*sin_look[zombies[k].dir]);

			//set animation based on which direction it started walking
			if(zombies[k].health > 60)
			{
				if(zombies[k].dir < 23 || zombies[k].dir > 337)
					Set_Animation_BOB(&zombies[k],PLAYER_EAST);
				else if(zombies[k].dir > 22 && zombies[k].dir < 68)
					Set_Animation_BOB(&zombies[k],PLAYER_SEAST);
				else if(zombies[k].dir > 67 && zombies[k].dir < 113)
					Set_Animation_BOB(&zombies[k],PLAYER_SOUTH);
				else if(zombies[k].dir > 112 && zombies[k].dir < 158)
					Set_Animation_BOB(&zombies[k],PLAYER_SWEST);
				else if(zombies[k].dir > 157 && zombies[k].dir < 203)
					Set_Animation_BOB(&zombies[k],PLAYER_WEST);
				else if(zombies[k].dir > 202 && zombies[k].dir < 248)
					Set_Animation_BOB(&zombies[k],PLAYER_NWEST);
				else if(zombies[k].dir > 247 && zombies[k].dir < 293)
					Set_Animation_BOB(&zombies[k],PLAYER_NORTH);
				else if(zombies[k].dir > 292 && zombies[k].dir < 338)
					Set_Animation_BOB(&zombies[k],PLAYER_NEAST);
			}
		}

		//update position
		zombies[k].x += zombies[k].xv;
		zombies[k].y += zombies[k].yv;

		//check if zombie is in contact with player
		if((zombies[0].x < zombies[k].x+zombies[k].width) &&
			(zombies[0].x+zombies[0].width > zombies[k].x) &&
			(zombies[0].y < zombies[k].y+zombies[k].height) &&
			(zombies[0].y+zombies[0].height > zombies[k].y))
		{
			if(zombies[0].health > 0)
			{
				if((zombies[0].x+12 < zombies[k].x+zombies[k].width-12) &&
					(zombies[0].x+zombies[0].width-12 > zombies[k].x+12) &&
					(zombies[0].y < zombies[k].y+zombies[k].height/2) &&
					(zombies[0].y+zombies[0].height/2 > zombies[k].y))
				{
					//move him back to where he was
					zombies[k].x -= zombies[k].xv;
					zombies[k].y -= zombies[k].yv;
					zombies[k].moving = 0;	//not moving

					zombies[0].x -= dx;
					zombies[0].y -= dy;
				}

				if(zombies[k].swing_timer == SWING_TIME)
				{
					zombies[k].swing_timer = 0;
					zombieAttack(k,-1);
				}
				if(zombies[0].swing_timer == 0)
				{
					//increase player's health by half of what it had
					if (zombies[k].health/2 - zombies.size()*2 > 0)
						zombies[0].health += zombies[k].health/2 - zombies.size()*2;

					zombies[k].health = 0;		//kill it
				}
			}

			//play melee sound
			if(zombies[k].swing_timer == 0)
				DSound_Play(sound_ids[0],0);
		}

		//if it isn't touching player it should be moving
		else zombies[k].moving = 1;

		for(int h=0;h<humans.size();h++)
		{
			///////////////////////////////////////////////////////
			//check for collisions with laser sights
			///////////////////////////////////////////////////////
			if(humans[h].curr_animation/2%2 == 0)//facing left or right
			{
				if((lasers[h].x < zombies[k].x+zombies[k].width-12) &&
					(lasers[h].x+lasers[h].width > zombies[k].x+12) &&
					(lasers[h].y + 72 < zombies[k].y+zombies[k].height) &&
					(lasers[h].y + 75 > zombies[k].y))
				{
					if(humans[h].swing_timer == SWING_TIME)
					{
						humans[h].swing_timer = 0;
						humans[h].swing_anim_timer = 0;
						zombies[k].health -= 25;

						//play shooting sound
						DSound_Play(sound_ids[1],0);

					}
				}
			}
			else if(humans[h].curr_animation/2%2 == 1)//facing up or down
			{
				if((lasers[h].x + 72 < zombies[k].x+zombies[k].width) &&
					(lasers[h].x + 75 > zombies[k].x) &&
					(lasers[h].y < zombies[k].y+zombies[k].height) &&
					(lasers[h].y + lasers[h].height > zombies[k].y))
				{
					if(humans[h].swing_timer == SWING_TIME)
					{
						humans[h].swing_timer = 0;
						humans[h].swing_anim_timer = 0;
						zombies[k].health -= 25;

						//play shooting sound
						DSound_Play(sound_ids[1],0);
					}
				}
			}
			//check if zombie is in contact with player
			if((zombies[k].x < humans[h].x+72) &&
				(zombies[k].x+zombies[k].width > humans[h].x) &&
				(zombies[k].y < humans[h].y+80) &&
				(zombies[k].y+zombies[k].height > humans[h].y))
			{
				if((zombies[k].x+12 < humans[h].x+62) &&
				(zombies[k].x+zombies[k].width-12 > humans[h].x+7) &&
					(zombies[k].y < humans[h].y+80/2) &&
					(zombies[k].y+zombies[k].height/2 > humans[h].y))
				{
					//move him back to where he was
					humans[h].x -= humans[h].xv;
					humans[h].y -= humans[h].yv;
					humans[h].moving = 0;	//not moving
				}

				if(zombies[k].swing_timer == SWING_TIME)
				{
					zombies[k].swing_timer = 0;
					zombieAttack(k,h);

					//play melee sound
					DSound_Play(sound_ids[0],0);
				}
			}

		}

		player_dying(k);

		//check for collisions with screen border
		if(zombies[k].x < 0)
		{
			//update position and velocity
			zombies[k].x = 0;
			zombies[k].xv = -zombies[k].xv;
			//update animation
			if(zombies[k].curr_animation == PLAYER_NWEST)
				Set_Animation_BOB(&zombies[k], PLAYER_NEAST);
			else if(zombies[k].curr_animation == PLAYER_WEST)
				Set_Animation_BOB(&zombies[k], PLAYER_EAST);
			else if(zombies[k].curr_animation == PLAYER_SWEST)
				Set_Animation_BOB(&zombies[k], PLAYER_SEAST);
		}
		else if(zombies[k].x > SCREEN_WIDTH-zombies[k].width)
		{
			//update position and velocity
			zombies[k].x = SCREEN_WIDTH-zombies[k].width;
			zombies[k].xv = -zombies[k].xv;
			//update animation
			if(zombies[k].curr_animation == PLAYER_NEAST)
				Set_Animation_BOB(&zombies[k], PLAYER_NWEST);
			else if(zombies[k].curr_animation == PLAYER_EAST)
				Set_Animation_BOB(&zombies[k], PLAYER_WEST);
			else if(zombies[k].curr_animation == PLAYER_SEAST)
				Set_Animation_BOB(&zombies[k], PLAYER_SWEST);
		}
		if(zombies[k].y < 0)
		{
			//update position and velocity
			zombies[k].y = 0;
			zombies[k].yv = -zombies[k].yv;
			//update animation
			if(zombies[k].curr_animation == PLAYER_NWEST)
				Set_Animation_BOB(&zombies[k], PLAYER_SWEST);
			else if(zombies[k].curr_animation == PLAYER_NORTH)
				Set_Animation_BOB(&zombies[k], PLAYER_SOUTH);
			else if(zombies[k].curr_animation == PLAYER_NEAST)
				Set_Animation_BOB(&zombies[k], PLAYER_SEAST);
		}
		else if(zombies[k].y > SCREEN_HEIGHT-zombies[k].height)
		{
			//update position and velocity
			zombies[k].y = SCREEN_HEIGHT-zombies[k].height;
			zombies[k].yv = -zombies[k].yv;
			//update animation
			if(zombies[k].curr_animation == PLAYER_SWEST)
				Set_Animation_BOB(&zombies[k], PLAYER_NWEST);
			else if(zombies[k].curr_animation == PLAYER_SOUTH)
				Set_Animation_BOB(&zombies[k], PLAYER_NORTH);
			else if(zombies[k].curr_animation == PLAYER_SEAST)
				Set_Animation_BOB(&zombies[k], PLAYER_NEAST);
		}

		//if its dead delete it with an iterator
		if(zombies[k].health <= 0)
		{
			std::vector<BOB>::iterator iter = zombies.begin();
			for(int i=0;i<k;i++)
				iter++;

			zombies.erase(iter);
			//move loop index back one since we deleted a zombie
			k--;

			if((zombies[0].health > 0 || minions.size() > 0) && zombies[0].swing_timer == 0)	score += 250;
		}
	}
}

void moveHumans()
{
	//move each of the humans
	for(int k = 0;k<humans.size();k++)
	{
		//update timers
		humans[k].move_timer -= Get_Clock() - start_clock_count + 30;	
		humans[k].swing_timer += Get_Clock() - start_clock_count + 30;
		humans[k].swing_anim_timer += Get_Clock() - start_clock_count + 30;
	
		//handle timers
		if(humans[k].swing_timer > SWING_TIME)
			humans[k].swing_timer = SWING_TIME;	

		if(humans[k].swing_anim_timer > SWING_ANIM_TIME)
			humans[k].swing_anim_timer = SWING_ANIM_TIME;

		if(humans[k].move_timer < 0)
		{
			//reset timer
			humans[k].move_timer = 1500;
			//give a random velocity vector
			humans[k].dir = rand()%90 + humans[k].dir - 45;
			if(humans[k].dir > 360) humans[k].dir -= 360;
			else if(humans[k].dir < 0) humans[k].dir += 360;
			Set_Vel_BOB(&humans[k],2.0*cos_look[humans[k].dir],2.0*sin_look[humans[k].dir]);

			//set animation based on which direction it started walking
			if(humans[k].dir < 46 || humans[k].dir > 315)
			  Set_Animation_BOB(&humans[k],PLAYER_EAST);
			else if(humans[k].dir > 45 && humans[k].dir < 136)
				Set_Animation_BOB(&humans[k],PLAYER_SOUTH);
			else if(humans[k].dir > 135 && humans[k].dir < 226)
				Set_Animation_BOB(&humans[k],PLAYER_WEST);
			else if(humans[k].dir > 225 && humans[k].dir < 316)
				Set_Animation_BOB(&humans[k],PLAYER_NORTH);
		}

		//update position
		humans[k].x += humans[k].xv;
		humans[k].y += humans[k].yv;

		//check if zombie is in contact with player
		if((zombies[0].x < humans[k].x+72) &&
			(zombies[0].x+zombies[0].width > humans[k].x) &&
			(zombies[0].y < humans[k].y+80) &&
			(zombies[0].y+zombies[0].height > humans[k].y))
		{
			if(zombies[0].health > 0)
			{
				if((zombies[0].x+12 < humans[k].x+62) &&
					(zombies[0].x+zombies[0].width-12 > humans[k].x+7) &&
					(zombies[0].y < humans[k].y+80/2) &&
					(zombies[0].y+zombies[0].height/2 > humans[k].y))
				{
					humans[k].x -= humans[k].xv;
					humans[k].y -= humans[k].yv;

					zombies[0].x -= dx;
					zombies[0].y -= dy;
				}

				if(zombies[0].swing_timer == 0)
				{
					humans[k].health -= 25;					

					//play melee sound
					DSound_Play(sound_ids[0],0);
				}
			}
		}
		//if it isn't touching player it should be moving
		else humans[k].moving = 1;

		//check for collisions with screen border
		if(humans[k].x < 0)
		{
			//update position and velocity
			humans[k].x = 0;
			humans[k].xv = -humans[k].xv;
			//update animation
			if(humans[k].curr_animation == PLAYER_WEST)
				Set_Animation_BOB(&humans[k], PLAYER_EAST);
		}
		else if(humans[k].x > SCREEN_WIDTH-humans[k].width)
		{
			//update position and velocity
			humans[k].x = SCREEN_WIDTH-humans[k].width;
			humans[k].xv = -humans[k].xv;
			//update animation
			if(humans[k].curr_animation == PLAYER_EAST)
				Set_Animation_BOB(&humans[k], PLAYER_WEST);
		}
		if(humans[k].y < 0)
		{
			//update position and velocity
			humans[k].y = 0;
			humans[k].yv = -humans[k].yv;
			//update animation
			if(humans[k].curr_animation == PLAYER_NORTH)
				Set_Animation_BOB(&humans[k], PLAYER_SOUTH);
		}
		else if(humans[k].y > SCREEN_HEIGHT-humans[k].height)
		{
			//update position and velocity
			humans[k].y = SCREEN_HEIGHT-humans[k].height;
			humans[k].yv = -humans[k].yv;
			//update animation
			if(humans[k].curr_animation == PLAYER_SOUTH)
				Set_Animation_BOB(&humans[k], PLAYER_NORTH);
		}
		///////////////////////////////////////////////////////
		//check for collisions with laser sights
		///////////////////////////////////////////////////////
		if(humans[k].curr_animation/2%2 == 0)//facing left or right
		{
			if((lasers[k].x < zombies[0].x+zombies[0].width-12) &&
				(lasers[k].x+lasers[k].width > zombies[0].x+12) &&
				(lasers[k].y + 72 < zombies[0].y+zombies[0].height) &&
				(lasers[k].y + 75 > zombies[0].y))
			{
				if(humans[k].swing_timer == SWING_TIME && zombies[0].health > 0)
				{
					humans[k].swing_timer = 0;
					humans[k].swing_anim_timer = 0;
					zombies[0].health -= 25;

					//play shooting sound
					DSound_Play(sound_ids[1],0);
				}
			}
		}
		else if(humans[k].curr_animation/2%2 == 1)//facing up or down
		{
			if((lasers[k].x + 72 < zombies[0].x+zombies[0].width) &&
				(lasers[k].x + 75 > zombies[0].x) &&
				(lasers[k].y < zombies[0].y+zombies[0].height) &&
				(lasers[k].y + lasers[k].height > zombies[0].y))
			{
				if(humans[k].swing_timer == SWING_TIME && zombies[0].health > 0)
				{
					humans[k].swing_timer = 0;
					humans[k].swing_anim_timer = 0;
					zombies[0].health -= 25;

					//play shooting sound
					DSound_Play(sound_ids[1],0);
				}
			}
		}

		//if its dead delete it with an iterator
		if(humans[k].health <= 0)
		{
			std::vector<BOB>::iterator iter = humans.begin();
			for(int i=0;i<k;i++)
				iter++;

			humans.erase(iter);

			iter = lasers.begin();
			for(int i=0;i<k;i++)
				iter++;

			lasers.erase(iter);

			//move loop index back one since we deleted a human
			k--;

			if((zombies[0].health > 0 || minions.size() > 0) && zombies[0].swing_timer == 0)	score += 1000;
		}
	}
}

void moveMinions()
{
	//move each of the zombies
	for(int k = 0;k<minions.size();k++)
	{
		//update timers
		minions[k].swing_timer += Get_Clock() - start_clock_count + 30;
		minions[k].swing_anim_timer += Get_Clock() - start_clock_count + 30;
		minions[k].move_timer -= Get_Clock() - start_clock_count + 30;		
		minions[k].health_timer += Get_Clock() - start_clock_count + 30;
	
		//handle timers
		if(minions[k].swing_timer > SWING_TIME)
			minions[k].swing_timer = SWING_TIME;	

		if(minions[k].swing_anim_timer > SWING_ANIM_TIME)
			minions[k].swing_anim_timer = SWING_ANIM_TIME;

		if(minions[k].health_timer > HEALTH_TIME)
		{
			minions[k].health -= 15;
			minions[k].health_timer = 0;
		}

		if(minions[k].move_timer < 0)
		{
			//reset timer
			minions[k].move_timer = 1500;
			//give a random velocity vector
			minions[k].dir = rand()%180 + minions[k].dir - 90;
			if(minions[k].dir > 360) minions[k].dir -= 360;
			else if(minions[k].dir < 0) minions[k].dir += 360;
			Set_Vel_BOB(&minions[k],2.0*cos_look[minions[k].dir],2.0*sin_look[minions[k].dir]);

			//set animation based on which direction it started walking
			if(minions[k].health > 60)
			{
				if(minions[k].dir < 23 || minions[k].dir > 337)
					Set_Animation_BOB(&minions[k],PLAYER_EAST);
				else if(minions[k].dir > 22 && minions[k].dir < 68)
					Set_Animation_BOB(&minions[k],PLAYER_SEAST);
				else if(minions[k].dir > 67 && minions[k].dir < 113)
					Set_Animation_BOB(&minions[k],PLAYER_SOUTH);
				else if(minions[k].dir > 112 && minions[k].dir < 158)
					Set_Animation_BOB(&minions[k],PLAYER_SWEST);
				else if(minions[k].dir > 157 && minions[k].dir < 203)
					Set_Animation_BOB(&minions[k],PLAYER_WEST);
				else if(minions[k].dir > 202 && minions[k].dir < 248)
					Set_Animation_BOB(&minions[k],PLAYER_NWEST);
				else if(minions[k].dir > 247 && minions[k].dir < 293)
					Set_Animation_BOB(&minions[k],PLAYER_NORTH);
				else if(minions[k].dir > 292 && minions[k].dir < 338)
					Set_Animation_BOB(&minions[k],PLAYER_NEAST);
			}
		}

		//update position
		minions[k].x += minions[k].xv;
		minions[k].y += minions[k].yv;

		//check if zombie is in contact with player
		if((zombies[0].x < minions[k].x+minions[k].width) &&
			(zombies[0].x+zombies[0].width > minions[k].x) &&
			(zombies[0].y < minions[k].y+minions[k].height) &&
			(zombies[0].y+zombies[0].height > minions[k].y))
		{
			if(zombies[0].health > 0)
			{
				if(zombies[0].swing_timer == 0)
				{
					//increase player's health
					if (minions[k].health/2 - zombies.size()*2 > 0)
						zombies[0].health += minions[k].health/2;

					if(zombies[0].health > 100)
						zombies[0].health = 100;

					minions[k].health = 0;		//kill it
				}
			}
		}

		for(int z=1;z<zombies.size();z++)
		{
			//check if zombie is in contact with player
			if((zombies[z].x < minions[k].x+minions[k].width) &&
				(zombies[z].x+zombies[z].width > minions[k].x) &&
				(zombies[z].y < minions[k].y+minions[k].height) &&
				(zombies[z].y+zombies[z].height > minions[k].y))
			{
				if(zombies[z].health > 0)
				{
					if((zombies[z].x+12 < minions[k].x+minions[k].width-12) &&
						(zombies[z].x+zombies[z].width-12 > minions[k].x+12) &&
						(zombies[z].y < minions[k].y+minions[k].height/2) &&
						(zombies[z].y+zombies[z].height/2 > minions[k].y))
					{
						//move him back to where he was
						minions[k].x -= minions[k].xv;
						minions[k].y -= minions[k].yv;
						minions[k].moving = 0;	//not moving

						zombies[z].x -= dx;
						zombies[z].y -= dy;
					}
					
					if(minions[k].swing_timer == SWING_TIME)
					{
						minions[k].swing_timer = 0;
						
						zombies[z].health -= 50;
						
						//play melee sound
						if(minions[k].swing_timer == 0)
							DSound_Play(sound_ids[0],0);
						
						minions[k].swing_anim_timer = 0;
					}
					if(zombies[z].swing_timer == 0)
					{
						minions[k].health -= 25;		//kill it
						zombies[z].swing_anim_timer = 0;
					}
				}
			}
		}

		for(int h=0;h<humans.size();h++)
		{
			///////////////////////////////////////////////////////
			//check for collisions with laser sights
			///////////////////////////////////////////////////////
			if(humans[h].curr_animation/2%2 == 0)//facing left or right
			{
				if((lasers[h].x < minions[k].x+minions[k].width) &&
					(lasers[h].x+lasers[h].width > minions[k].x) &&
					(lasers[h].y + 72 < minions[k].y+minions[k].height) &&
					(lasers[h].y + 75 > minions[k].y))
				{
					if(humans[h].swing_timer == SWING_TIME)
					{
						humans[h].swing_timer = 0;
						humans[h].swing_anim_timer = 0;
						minions[k].health -= 25;

						//play shooting sound
						DSound_Play(sound_ids[1],0);

					}
				}
			}
			else if(humans[h].curr_animation/2%2 == 1)//facing up or down
			{
				if((lasers[h].x + 72 < minions[k].x+minions[k].width) &&
					(lasers[h].x + 75 > minions[k].x) &&
					(lasers[h].y < minions[k].y+minions[k].height) &&
					(lasers[h].y + lasers[h].height > minions[k].y))
				{
					if(humans[h].swing_timer == SWING_TIME)
					{
						humans[h].swing_timer = 0;
						humans[h].swing_anim_timer = 0;
						minions[k].health -= 25;

						//play shooting sound
						DSound_Play(sound_ids[1],0);
					}
				}
			}
			//check if zombie is in contact with player
			if((minions[k].x < humans[h].x+72) &&
				(minions[k].x+minions[k].width > humans[h].x) &&
				(minions[k].y < humans[h].y+80) &&
				(minions[k].y+minions[k].height > humans[h].y))
			{
				if((minions[k].x+12 < humans[h].x+60) &&
					(minions[k].x+minions[k].width-12 > humans[h].x+7) &&
					(minions[k].y < humans[h].y+80/2) &&
					(minions[k].y+minions[k].height/2 > humans[h].y))
				{
					//move him back to where he was
					humans[h].x -= humans[h].xv;
					humans[h].y -= humans[h].yv;
					humans[h].moving = 0;	//not moving
				}

				if(minions[k].swing_timer == SWING_TIME)
				{
					minions[k].swing_timer = 0;

					humans[h].health -= 25;
					minions[k].swing_anim_timer = 0;

					//play melee sound
					DSound_Play(sound_ids[0],0);
				}
			}

		}

		minion_dying(k);

		//check for collisions with screen border
		if(minions[k].x < 0)
		{
			//update position and velocity
			minions[k].x = 0;
			minions[k].xv = -minions[k].xv;
			//update animation
			if(minions[k].curr_animation == PLAYER_NWEST)
				Set_Animation_BOB(&minions[k], PLAYER_NEAST);
			else if(minions[k].curr_animation == PLAYER_WEST)
				Set_Animation_BOB(&minions[k], PLAYER_EAST);
			else if(minions[k].curr_animation == PLAYER_SWEST)
				Set_Animation_BOB(&minions[k], PLAYER_SEAST);
		}
		else if(minions[k].x > SCREEN_WIDTH-minions[k].width)
		{
			//update position and velocity
			minions[k].x = SCREEN_WIDTH-minions[k].width;
			minions[k].xv = -minions[k].xv;
			//update animation
			if(minions[k].curr_animation == PLAYER_NEAST)
				Set_Animation_BOB(&minions[k], PLAYER_NWEST);
			else if(minions[k].curr_animation == PLAYER_EAST)
				Set_Animation_BOB(&minions[k], PLAYER_WEST);
			else if(minions[k].curr_animation == PLAYER_SEAST)
				Set_Animation_BOB(&minions[k], PLAYER_SWEST);
		}
		if(minions[k].y < 0)
		{
			//update position and velocity
			minions[k].y = 0;
			minions[k].yv = -minions[k].yv;
			//update animation
			if(minions[k].curr_animation == PLAYER_NWEST)
				Set_Animation_BOB(&minions[k], PLAYER_SWEST);
			else if(minions[k].curr_animation == PLAYER_NORTH)
				Set_Animation_BOB(&minions[k], PLAYER_SOUTH);
			else if(minions[k].curr_animation == PLAYER_NEAST)
				Set_Animation_BOB(&minions[k], PLAYER_SEAST);
		}
		else if(minions[k].y > SCREEN_HEIGHT-minions[k].height)
		{
			//update position and velocity
			minions[k].y = SCREEN_HEIGHT-minions[k].height;
			minions[k].yv = -minions[k].yv;
			//update animation
			if(minions[k].curr_animation == PLAYER_SWEST)
				Set_Animation_BOB(&minions[k], PLAYER_NWEST);
			else if(minions[k].curr_animation == PLAYER_SOUTH)
				Set_Animation_BOB(&minions[k], PLAYER_NORTH);
			else if(minions[k].curr_animation == PLAYER_SEAST)
				Set_Animation_BOB(&minions[k], PLAYER_NEAST);
		}

		//if its dead delete it with an iterator
		if(minions[k].health <= 0)
		{
			std::vector<BOB>::iterator iter = minions.begin();
			for(int i=0;i<k;i++)
				iter++;

			minions.erase(iter);
			//move loop index back one since we deleted a zombie
			k--;

			if((zombies[0].health > 0 || minions.size() > 0) && zombies[0].swing_timer == 0)	score += 250;
		}
	}
}
void spawnMinions()
{
	//clear all current minions so there can't be more than one wave being spawned
	minions.clear();
	char filename[80]; // used to build up files names

	for(int k=0;k<4;k++)
	{
		//spawn one minion for each 1/4 of minion time (4 total if fully charged)
		if(zombies[0].minion_timer >= MINION_TIME / 4)
		{
			Minion_Init(k);
		
			zombies[0].minion_timer -= MINION_TIME/4;
		}
	}

	zombies[0].minion_timer = 0;
}
void handleSpawns()
{
	for(int k=0;k<8;k++)
	{
		//reduce all timers
		if(spawnRates[k] != -1)
			spawnTimers[k] -= Get_Clock() - start_clock_count + 30;
		//if one has reached zero handle it accordingly
		if(spawnTimers[k] < 0)
		{
			spawnRates[k] -= RESPAWN_DECREASE;		//reduce spawn time slightly
			spawnTimers[k] = spawnRates[k];	//reset timer
			Zombie_Init(k);					//spawn zombie at correct spawn point
			//after 5 zombies create a new spawn point
			if(k < 8 && spawnRates[k] == RESPAWN_TIME - 5*RESPAWN_DECREASE)
			{
				spawnRates[k+1]=RESPAWN_TIME;
				if(k < 7)
					Human_Init(k+2);
			}
			if(spawnRates[k] == RESPAWN_TIME -2*RESPAWN_DECREASE)
				Human_Init(k);
		}
	}
}

void zombieAttack(int z, int h)
{
	zombies[z].swing_anim_timer = 0;
	if(h == -1)
	{
		zombies[0].health -= 15;
	}
	else if(h >= 0)
	{
		humans[h].health -= 25;
	}
}

void player_dying()
{
	if(zombies[0].health <= 60 && zombies[0].health > 30)
	{
		Set_Animation_BOB(&zombies[0],PLAYER_DEATH);
		zombies[0].anim_index = 0;
	}
	if(zombies[0].health <= 30 && zombies[0].health > 10)
	{
		Set_Animation_BOB(&zombies[0],PLAYER_DEATH);
		zombies[0].anim_index = 1;
	}
	if(zombies[0].health <= 10)
	{
		Set_Animation_BOB(&zombies[0],PLAYER_DEATH);
		zombies[0].anim_index = 2;
	}
}

void player_dying(int k)
{
	if(zombies[k].health <= 60 && zombies[k].health > 30)
	{
		Set_Animation_BOB(&zombies[k],PLAYER_DEATH);
		zombies[k].anim_index = 0;
	}
	if(zombies[k].health <= 30 && zombies[k].health > 10)
	{
		Set_Animation_BOB(&zombies[k],PLAYER_DEATH);
		zombies[k].anim_index = 1;
	}
	if(zombies[k].health <= 10)
	{
		Set_Animation_BOB(&zombies[k],PLAYER_DEATH);
		zombies[k].anim_index = 2;
	}
}

void minion_dying(int k)
{
	if(minions[k].health <= 60 && minions[k].health > 30)
	{
		Set_Animation_BOB(&minions[k],PLAYER_DEATH);
		minions[k].anim_index = 0;
	}
	if(minions[k].health <= 30 && minions[k].health > 10)
	{
		Set_Animation_BOB(&minions[k],PLAYER_DEATH);
		minions[k].anim_index = 1;
	}
	if(minions[k].health <= 10)
	{
		Set_Animation_BOB(&minions[k],PLAYER_DEATH);
		minions[k].anim_index = 2;
	}
}